/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { CommodityChannelIndexIndicatorStrategy } from "./CommodityChannelIndexIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let CommodityChannelIndexIndicator = /*@__PURE__*/ (() => {
    class CommodityChannelIndexIndicator extends StrategyBasedIndicator {
        get_ug() {
            return new CommodityChannelIndexIndicatorStrategy();
        }
        get ug() {
            return this.get_ug();
        }
        get_ut() {
            return CommodityChannelIndexIndicator.$;
        }
        get ut() {
            return this.get_ut();
        }
        get u1() {
            return typeGetValue(this.c(CommodityChannelIndexIndicator.u2));
        }
        set u1(a) {
            this.h(CommodityChannelIndexIndicator.u2, a);
        }
        um() {
            return this.u1;
        }
        uv(a) {
            this.u1 = a;
        }
    }
    CommodityChannelIndexIndicator.$t = markType(CommodityChannelIndexIndicator, 'CommodityChannelIndexIndicator', StrategyBasedIndicator.$);
    CommodityChannelIndexIndicator.u2 = StrategyBasedIndicator.uy(20, CommodityChannelIndexIndicator.$);
    return CommodityChannelIndexIndicator;
})();
