/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DataLegendSummaryCalculationBase } from "./DataLegendSummaryCalculationBase";
import { IDataLegendSummaryCalculation_$type } from "./IDataLegendSummaryCalculation";
import { DataLegendSummaryResult } from "./DataLegendSummaryResult";
import { MathUtil } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let DataLegendSummaryCalculationMax = /*@__PURE__*/ (() => {
    class DataLegendSummaryCalculationMax extends DataLegendSummaryCalculationBase {
        get title() {
            return "Max";
        }
        calculate(a, b) {
            let c = this.a(a);
            if (c.length == 0) {
                return DataLegendSummaryResult.b;
            }
            let d = MathUtil.i(c);
            return new DataLegendSummaryResult(1, d, a, b);
        }
    }
    DataLegendSummaryCalculationMax.$t = markType(DataLegendSummaryCalculationMax, 'DataLegendSummaryCalculationMax', DataLegendSummaryCalculationBase.$, [IDataLegendSummaryCalculation_$type]);
    return DataLegendSummaryCalculationMax;
})();
