/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { DetrendedPriceOscillatorIndicatorStrategy } from "./DetrendedPriceOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let DetrendedPriceOscillatorIndicator = /*@__PURE__*/ (() => {
    class DetrendedPriceOscillatorIndicator extends StrategyBasedIndicator {
        get_ug() {
            return new DetrendedPriceOscillatorIndicatorStrategy();
        }
        get ug() {
            return this.get_ug();
        }
        get_ut() {
            return DetrendedPriceOscillatorIndicator.$;
        }
        get ut() {
            return this.get_ut();
        }
        get u1() {
            return typeGetValue(this.c(DetrendedPriceOscillatorIndicator.u2));
        }
        set u1(a) {
            this.h(DetrendedPriceOscillatorIndicator.u2, a);
        }
        um() {
            return this.u1;
        }
        uv(a) {
            this.u1 = a;
        }
    }
    DetrendedPriceOscillatorIndicator.$t = markType(DetrendedPriceOscillatorIndicator, 'DetrendedPriceOscillatorIndicator', StrategyBasedIndicator.$);
    DetrendedPriceOscillatorIndicator.u2 = StrategyBasedIndicator.uy(20, DetrendedPriceOscillatorIndicator.$);
    return DetrendedPriceOscillatorIndicator;
})();
