/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
export let FullStochasticOscillatorIndicator = /*@__PURE__*/ (() => {
    class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
        constructor() {
            super();
            this.trendLineBrush = ((() => {
                let $ret = new Brush();
                $ret.fill = "#565656";
                return $ret;
            })());
            this.trendLineType = 10;
            this.trendLinePeriod = 3;
        }
        get_ug() {
            return new FullStochasticOscillatorIndicatorStrategy();
        }
        get ug() {
            return this.get_ug();
        }
        get_ut() {
            return FullStochasticOscillatorIndicator.$;
        }
        get ut() {
            return this.get_ut();
        }
        get u1() {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.u6));
        }
        set u1(a) {
            this.h(FullStochasticOscillatorIndicator.u6, a);
        }
        um() {
            return this.u1;
        }
        uv(a) {
            this.u1 = a;
        }
        get smoothingPeriod() {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.u7));
        }
        set smoothingPeriod(a) {
            this.h(FullStochasticOscillatorIndicator.u7, a);
        }
        uo() {
            return this.smoothingPeriod;
        }
        get u3() {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.u8));
        }
        set u3(a) {
            this.h(FullStochasticOscillatorIndicator.u8, a);
        }
        ul() {
            return this.u3;
        }
        tw() {
            return this.u3;
        }
    }
    FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
    FullStochasticOscillatorIndicator.u6 = StrategyBasedIndicator.uy(14, FullStochasticOscillatorIndicator.$);
    FullStochasticOscillatorIndicator.u7 = StrategyBasedIndicator.uz(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
    FullStochasticOscillatorIndicator.u8 = StrategyBasedIndicator.uz(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
    return FullStochasticOscillatorIndicator;
})();
