/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { RateOfChangeAndMomentumIndicatorStrategy } from "./RateOfChangeAndMomentumIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let RateOfChangeAndMomentumIndicator = /*@__PURE__*/ (() => {
    class RateOfChangeAndMomentumIndicator extends StrategyBasedIndicator {
        get_ug() {
            return new RateOfChangeAndMomentumIndicatorStrategy();
        }
        get ug() {
            return this.get_ug();
        }
        get_ut() {
            return RateOfChangeAndMomentumIndicator.$;
        }
        get ut() {
            return this.get_ut();
        }
        get u1() {
            return typeGetValue(this.c(RateOfChangeAndMomentumIndicator.u2));
        }
        set u1(a) {
            this.h(RateOfChangeAndMomentumIndicator.u2, a);
        }
        um() {
            return this.u1;
        }
        uv(a) {
            this.u1 = a;
        }
    }
    RateOfChangeAndMomentumIndicator.$t = markType(RateOfChangeAndMomentumIndicator, 'RateOfChangeAndMomentumIndicator', StrategyBasedIndicator.$);
    RateOfChangeAndMomentumIndicator.u2 = StrategyBasedIndicator.uy(14, RateOfChangeAndMomentumIndicator.$);
    return RateOfChangeAndMomentumIndicator;
})();
