/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { typeCast, runOn, markType } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Defaults } from "./Defaults";
import { ISortingAxis_$type } from "./ISortingAxis";
/**
 * @hidden
 */
export let SplineSeries = /*@__PURE__*/ (() => {
    class SplineSeries extends SplineSeriesBase {
        constructor() {
            super();
            this.vq = null;
            this.vq = new CategoryLineRasterizer();
            this.ab = SplineSeries.$;
        }
        get_eg() {
            return true;
        }
        bx() {
            return new SplineSeriesView(this);
        }
        ly(a) {
            super.ly(a);
            this.vr = a;
        }
        preferredCategoryMode(a) {
            return 0;
        }
        kx(a, b) {
            super.kx(a, b);
            let c = b;
            c.dd();
        }
        s6(a, b) {
            super.s6(a, b);
            let c = b;
            let d = c.cr.d;
            let e = typeCast(SplineSeriesView.$, b);
            let f = a.f;
            let g = this.getEffectiveViewport1(b);
            this.rw.a0(this, this.sg(), runOn(this, this.rh), this.so(b), this.sp(b));
            let h = false;
            let i = this.rw.b;
            if (i != null) {
                h = true;
            }
            if (h) {
                let j = new ScalerParams(0, b.bv, b.bu, this.un.cg, g);
                this.s2(f, -1, this.valueColumn.count, this.un, j, b.q);
            }
            let k = e.dj;
            let l = e.dk;
            let m = e.di;
            this.rw.ad(k, true, false, true, false);
            this.rw.ad(l, true, false, true, false);
            this.rw.ad(m, false, true, false, false);
            m._opacity = 0.75 * this.rw.j;
            if (b.cv(a)) {
                e.de(f.count, f, true, 1, this.te(f, f.count - 1, b.bu, b.bv), d, this.ft);
                b.cy(a);
            }
        }
        get useHighMarkerFidelity() {
            return this.sj;
        }
    }
    SplineSeries.$t = markType(SplineSeries, 'SplineSeries', SplineSeriesBase.$);
    return SplineSeries;
})();
/**
 * @hidden
 */
export let SplineSeriesView = /*@__PURE__*/ (() => {
    class SplineSeriesView extends SplineSeriesBaseView {
        constructor(a) {
            super(a);
            this.dc = null;
            this.dm = new Path();
            this.dl = new Path();
            this.dn = new Path();
            this.dh = new Path();
            this.dg = new Path();
            this.df = new Path();
            this.dc = a;
        }
        as() {
            super.as();
            if (!this.q) {
                this.dc.qc = Defaults.e;
            }
        }
        get dj() {
            return this.dm;
        }
        get dk() {
            return this.dn;
        }
        get di() {
            return this.dl;
        }
        dd() {
            this.dl.ak = null;
            this.dm.ak = null;
            this.dn.ak = null;
            this.aq();
        }
        de(a, b, c, d, e, f, g) {
            this.dc.vq.a = typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
            this.dc.vq.m(this.dm, this.dl, this.dn, a, b, c, d, e, f, g);
            this.aq();
        }
        bc() {
            super.bc();
            this.dg.ak = this.dm.ak;
            this.dh.ak = this.dn.ak;
            this.df.ak = this.dl.ak;
            let a = this.bo();
            this.dg._stroke = a;
            this.dg.ac = this.e.fu + 3;
            this.dh._stroke = a;
            this.dh.ac = this.e.fu + 3;
            this.df._fill = a;
            this.df._opacity = 1;
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                if (b) {
                    a.s(this.df);
                    a.s(this.dg);
                    a.s(this.dh);
                }
                else {
                    a.s(this.dl);
                    a.s(this.dm);
                    a.s(this.dn);
                }
            }
        }
        al(a) {
            super.al(a);
            this.e.a8.exportPathData(a, this.dm, "lowerShape", ["Lower", "Main"]);
            this.e.a8.exportPathData(a, this.dn, "upperShape", ["Upper"]);
            this.e.a8.exportPathData(a, this.dl, "translucentShape", ["Translucent"]);
        }
    }
    SplineSeriesView.$t = markType(SplineSeriesView, 'SplineSeriesView', SplineSeriesBaseView.$);
    return SplineSeriesView;
})();
