/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { StochRSIIndicatorStrategy } from "./StochRSIIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let StochRSIIndicator = /*@__PURE__*/ (() => {
    class StochRSIIndicator extends StrategyBasedIndicator {
        get_ug() {
            return new StochRSIIndicatorStrategy();
        }
        get ug() {
            return this.get_ug();
        }
        get_ut() {
            return StochRSIIndicator.$;
        }
        get ut() {
            return this.get_ut();
        }
        get u1() {
            return typeGetValue(this.c(StochRSIIndicator.u2));
        }
        set u1(a) {
            this.h(StochRSIIndicator.u2, a);
        }
        um() {
            return this.u1;
        }
        uv(a) {
            this.u1 = a;
        }
    }
    StochRSIIndicator.$t = markType(StochRSIIndicator, 'StochRSIIndicator', StrategyBasedIndicator.$);
    StochRSIIndicator.u2 = StrategyBasedIndicator.uy(14, StochRSIIndicator.$);
    return StochRSIIndicator;
})();
