import { PieSliceOthersContext as PieSliceOthersContext_internal } from "./PieSliceOthersContext";
/**
 * Represents the selected data contained inside the Others slice.
*/
export class IgxPieSliceOthersContext {
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new PieSliceOthersContext_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The underlying data contained by the Others pie slice.
    */
    findByName(name) {
        return null;
    }
}
