/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Number_$type, typeCast, runOn, markType, markDep, getEnumerator, Point_$type, fromEnum } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { Series } from "./Series";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Flattener } from "igniteui-angular-core";
/**
 * @hidden
 */
var BollingerBandsOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsOverlay, _super);
    function BollingerBandsOverlay() {
        var _this = _super.call(this) || this;
        _this.tt = 0;
        _this.tu = 0;
        _this.tr = new List$1(Number_$type, 0);
        _this.ts = new List$1(Number_$type, 0);
        _this.ab = BollingerBandsOverlay.$;
        _this.qf = new CategoryFrame(4);
        _this.qh = new CategoryFrame(4);
        _this.qd = new CategoryFrame(4);
        return _this;
    }
    BollingerBandsOverlay.prototype.l3 = function (a, b, c, d) {
        if (this.ru().contains(b)) {
            this.tl = false;
        }
        _super.prototype.l3.call(this, a, b, c, d);
        switch (b) {
            case BollingerBandsOverlay.$$p[1]:
                this.tl = false;
                this.mh(false);
                break;
            case BollingerBandsOverlay.$$p[0]:
                this.mh(false);
                break;
        }
    };
    BollingerBandsOverlay.prototype.tm = function () {
        this.tr.clear();
        this.ts.clear();
        var a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.rt), this.tw));
        var b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.rt), this.tw));
        this.tu = 1.7976931348623157E+308;
        this.tt = -1.7976931348623157E+308;
        var c = true;
        var d = true;
        var e = this.tv;
        while (c || d) {
            if (a.moveNext()) {
                this.tr.add(a.current);
            }
            else {
                c = false;
            }
            if (b.moveNext()) {
                this.ts.add(b.current);
            }
            else {
                d = false;
            }
            if (c && d) {
                this.tu = Math.min(this.tu, a.current - b.current * e);
                this.tt = Math.max(this.tt, a.current + b.current * e);
            }
        }
        return true;
    };
    BollingerBandsOverlay.prototype.ap = function (a) {
        if (this.tr == null || this.ts == null || a == null || this.ck == null || a != this.qx) {
            return null;
        }
        var b = new AxisRange(this.tu, this.tt);
        return b;
    };
    BollingerBandsOverlay.prototype.s2 = function (a, b) {
        _super.prototype.s2.call(this, a, b);
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.qb;
        var g = this.qx;
        var h = new ScalerParams(0, c, d, f.cg, e);
        var i = new ScalerParams(0, c, d, g.cg, e);
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = typeCast(ISortingAxis_$type, this.qb);
        if (j != null && j.i$b.count != this.ck.count) {
            return;
        }
        var k = 0;
        k = this.r2(c, d, e);
        if (!this.tl) {
            this.tl = this.tm();
            if (this.qx != null) {
                this.qx.c1(true);
            }
        }
        i.b = this.gc();
        var l = this.qb.el(2, h) - this.qb.el(1, h);
        for (var m = b.bx.c; m <= b.bx.d; ++m) {
            var n = void 0;
            if (j == null) {
                n = b.bx.getBucket(m);
            }
            else {
                var o = j.i$b._inner[m];
                var p = j.i$d(o);
                var q = this.tr._inner[m];
                var r = this.ts._inner[m];
                var s = q;
                var t = r;
                var u = p;
                var v = 1;
                while (m < b.bx.d) {
                    o = j.i$b._inner[m + 1];
                    u = j.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s += this.tr._inner[m];
                    t += this.ts._inner[m];
                    v++;
                }
                s /= v;
                t /= v;
                var w = s - t * this.tv;
                var x = s;
                var y = s + t * this.tv;
                var z = NaN;
                if (!isNaN_(p)) {
                    z = this.qb.ei(p, h);
                }
                n = [z, w, x, y];
            }
            var aa = Math.max(1, l);
            if (!isNaN_(n[0]) && m * aa >= this.tn) {
                if (this.qb != null && typeCast(ISortingAxis_$type, this.qb) !== null) {
                    n[0] = n[0] + k;
                }
                else {
                    n[0] = f.ei(n[0], h) + k;
                }
                n[1] = g.ei(n[1], i);
                n[2] = g.ei(n[2], i);
                n[3] = g.ei(n[3], i);
                a.f.add(n);
            }
        }
    };
    BollingerBandsOverlay.prototype.kx = function (a, b) {
        _super.prototype.kx.call(this, a, b);
        var c = b;
        if (c != null) {
            c.b4();
        }
    };
    BollingerBandsOverlay.prototype.gj = function (a, b, c) {
        if (this.tr == null) {
            return _super.prototype.gj.call(this, a, b, c);
        }
        var d = this.getEffectiveViewport1(this.b0);
        var e = this.r2(this.b0.bv, this.b0.bu, d);
        var f = new ScalerParams(0, this.b0.bv, this.b0.bu, this.qb.cg, d);
        f.c = this.cd.su;
        return this.gl(this.tr, a, this.qb, f, e, runOn(this, this.r1), b, c);
    };
    BollingerBandsOverlay.prototype.hj = function (a, b) {
        if (this.tr == null) {
            return _super.prototype.hj.call(this, a, b);
        }
        return this.hk(a, b, this.qb, runOn(this, this.r1), this.tr);
    };
    BollingerBandsOverlay.prototype.hh = function (a, b) {
        if (this.tr == null) {
            return _super.prototype.hh.call(this, a, b);
        }
        return this.hi(a, b, this.qb, runOn(this, this.r1), this.tr);
    };
    BollingerBandsOverlay.prototype.e9 = function (a, b, c) {
        var d = _super.prototype.e9.call(this, a, b, c);
        if (!this.rk(this.ru())) {
            d = false;
        }
        return d;
    };
    BollingerBandsOverlay.prototype.s4 = function (a, b) {
        _super.prototype.s4.call(this, a, b);
        var c = typeCast(BollingerBandsOverlayView.$, b);
        var d = this.getEffectiveViewport1(b);
        if (b.b0(a)) {
            c.b4();
            var e_1 = a.f.count;
            var f = function (g) { return a.f._inner[g][0]; };
            var g = function (h) { return a.f._inner[e_1 - 1 - h][0]; };
            var h = function (i) { return a.f._inner[i][1]; };
            var i = function (j) { return a.f._inner[j][2]; };
            var j = function (k) { return a.f._inner[e_1 - 1 - k][3]; };
            c.b5(e_1, f, g, h, i, j);
            b.b2(a);
        }
        this.qk.a0(this, this.rj(), runOn(this, this.p3), this.r8(b), this.sa(b));
        var k = false;
        var l = this.qk.b;
        var m = a.f;
        var n = this.ck.count;
        if (l != null) {
            k = true;
        }
        if (k) {
            var o = new ScalerParams(0, b.bv, b.bu, this.qb.cg, d);
            this.s1(m, -1, n, this.qb, o, b.q);
        }
        var p = c.cc;
        var q = c.cd;
        var r = c.ce;
        var s = c.b7;
        this.qk.ad(q, true, false, true, true);
        this.qk.an = null;
        this.qk.am = null;
        this.qk.ad(p, true, false, false, true);
        this.qk.ad(r, true, false, false, true);
        this.qk.ad(s, false, true, false, false);
        s._opacity = this.qk.j * this.fq;
    };
    BollingerBandsOverlay.prototype.bx = function () {
        return new BollingerBandsOverlayView(this);
    };
    BollingerBandsOverlay.prototype.ly = function (a) {
        _super.prototype.ly.call(this, a);
        this.tq = typeCast(BollingerBandsOverlayView.$, a);
    };
    BollingerBandsOverlay.prototype.sb = function () {
        return 3;
    };
    BollingerBandsOverlay.prototype.gc = function () {
        return Series.ge(this.tr, null);
    };
    BollingerBandsOverlay.$t = markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
    BollingerBandsOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:tv:tz', [1, 2], 'Period:tw:t0', [1, 14]]);
    return BollingerBandsOverlay;
}(FinancialOverlay));
export { BollingerBandsOverlay };
/**
 * @hidden
 */
var BollingerBandsBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsBucketCalculator, _super);
    function BollingerBandsBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    BollingerBandsBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.a.bz.ck.count - 1);
        if (b <= c) {
            var d = this.f.b3.tv;
            var e = 0;
            var f = 0;
            var g = 0;
            for (var h = b; h <= c; ++h) {
                if (!isNaN_(this.f.b3.tr._inner[h]) && !isNaN_(this.f.b3.ts._inner[h])) {
                    e += this.f.b3.tr._inner[h];
                    f += this.f.b3.ts._inner[h];
                    ++g;
                }
            }
            if (g > 0) {
                e = e / g;
                f = f / g;
                return [0.5 * (b + c), e - f * d, e, e + f * d];
            }
        }
        return [NaN, NaN, NaN, NaN];
    };
    BollingerBandsBucketCalculator.$t = markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
    return BollingerBandsBucketCalculator;
}(FinancialBucketCalculator));
export { BollingerBandsBucketCalculator };
/**
 * @hidden
 */
var BollingerBandsOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsOverlayView, _super);
    function BollingerBandsOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.b3 = null;
        _this.b8 = new Polygon();
        _this.cf = new Polyline();
        _this.cg = new Polyline();
        _this.ch = new Polyline();
        _this.b6 = new Polygon();
        _this.b9 = new Polyline();
        _this.ca = new Polyline();
        _this.cb = new Polyline();
        _this.b3 = a;
        return _this;
    }
    BollingerBandsOverlayView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
        }
    };
    BollingerBandsOverlayView.prototype.by = function () {
        return new BollingerBandsBucketCalculator(this);
    };
    BollingerBandsOverlayView.prototype.b5 = function (a, b, c, d, e, f) {
        var e_2, _a, e_3, _b, e_4, _c;
        try {
            for (var _d = __values(fromEnum(Flattener.d(a, b, d, this.e.ft))), _e = _d.next(); !_e.done; _e = _d.next()) {
                var g = _e.value;
                this.b8.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
                this.cf.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return))
                    _a.call(_d);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        try {
            for (var _f = __values(fromEnum(Flattener.d(a, b, e, this.e.ft))), _g = _f.next(); !_g.done; _g = _f.next()) {
                var h = _g.value;
                this.cg.ak.add({ $type: Point_$type, x: b(h), y: e(h) });
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return))
                    _b.call(_f);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        try {
            for (var _h = __values(fromEnum(Flattener.d(a, c, f, this.e.ft))), _j = _h.next(); !_j.done; _j = _h.next()) {
                var i = _j.value;
                this.b8.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
                this.ch.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_j && !_j.done && (_c = _h.return))
                    _c.call(_h);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.aq();
    };
    BollingerBandsOverlayView.prototype.b4 = function () {
        this.b8.ak.clear();
        this.cf.ak.clear();
        this.cg.ak.clear();
        this.ch.ak.clear();
        this.aq();
    };
    Object.defineProperty(BollingerBandsOverlayView.prototype, "b7", {
        get: function () {
            return this.b8;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "cc", {
        get: function () {
            return this.cf;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "cd", {
        get: function () {
            return this.cg;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "ce", {
        get: function () {
            return this.ch;
        },
        enumerable: false,
        configurable: true
    });
    BollingerBandsOverlayView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        this.b6.ak = this.b8.ak;
        this.b9.ak = this.cf.ak;
        this.ca.ak = this.cg.ak;
        this.cb.ak = this.ch.ak;
        var a = this.bo();
        this.b6._fill = a;
        this.b6._opacity = 1;
        this.b9._stroke = a;
        this.b9.ac = this.e.fu + 3;
        this.ca._stroke = a;
        this.ca.ac = this.e.fu + 3;
        this.cb._stroke = a;
        this.cb.ac = this.e.fu + 3;
    };
    BollingerBandsOverlayView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d) {
            if (b) {
                a.t(this.b6);
                a.u(this.b9);
                a.u(this.ca);
                a.u(this.cb);
            }
            else {
                a.t(this.b8);
                a.u(this.cf);
                a.u(this.cg);
                a.u(this.ch);
            }
        }
    };
    BollingerBandsOverlayView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        this.e.a8.exportPolygonData(a, this.b8, "FillShape", ["Fill"]);
        this.e.a8.exportPolylineData(a, this.cf, "BottomLine", ["Lower", "Main"]);
        this.e.a8.exportPolylineData(a, this.cg, "CentralLine", ["Central"]);
        this.e.a8.exportPolylineData(a, this.ch, "TopLine", ["Upper"]);
    };
    BollingerBandsOverlayView.$t = markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
    return BollingerBandsOverlayView;
}(FinancialSeriesView));
export { BollingerBandsOverlayView };
