/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { DataLegendSummaryCalculationBase } from "./DataLegendSummaryCalculationBase";
import { IDataLegendSummaryCalculation_$type } from "./IDataLegendSummaryCalculation";
import { DataLegendSummaryResult } from "./DataLegendSummaryResult";
import { MathUtil } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var DataLegendSummaryCalculationTotal = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataLegendSummaryCalculationTotal, _super);
    function DataLegendSummaryCalculationTotal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DataLegendSummaryCalculationTotal.prototype, "title", {
        get: function () {
            return "Total";
        },
        enumerable: false,
        configurable: true
    });
    DataLegendSummaryCalculationTotal.prototype.calculate = function (a, b) {
        var c = this.a(a);
        if (c.length == 0) {
            return DataLegendSummaryResult.b;
        }
        var d = MathUtil.q(c);
        return new DataLegendSummaryResult(1, d, a, b);
    };
    DataLegendSummaryCalculationTotal.$t = markType(DataLegendSummaryCalculationTotal, 'DataLegendSummaryCalculationTotal', DataLegendSummaryCalculationBase.$, [IDataLegendSummaryCalculation_$type]);
    return DataLegendSummaryCalculationTotal;
}(DataLegendSummaryCalculationBase));
export { DataLegendSummaryCalculationTotal };
