import { __extends } from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { Axis as Axis_internal } from './Axis';
import { IgxAxisComponent as IgxAxisComponent } from './igx-axis-component';
var IgxAxisCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxAxisCollection, _super);
    function IgxAxisCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxAxisComponent.$type) {
            IgxAxisComponent.$type = markType(IgxAxisComponent, "IgxAxisComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxAxisCollection.prototype._createInnerColl = function () {
        if (!IgxAxisComponent.$type) {
            IgxAxisComponent.$type = markType(IgxAxisComponent, "IgxAxisComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxAxisComponent.$type, Axis_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgxAxisComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxAxisCollection;
}(IgCollection));
export { IgxAxisCollection };
