import { FinancialOverlay } from "./FinancialOverlay";
import { List$1 } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { AxisRange } from "./AxisRange";
import { Axis } from "./Axis";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class BollingerBandsOverlay extends FinancialOverlay {
    static $t: Type;
    constructor();
    tw: number;
    tv: number;
    protected l3(a: any, b: string, c: any, d: any): void;
    private tt;
    private tu;
    protected tm(): boolean;
    ap(a: Axis): AxisRange;
    tr: List$1<number>;
    ts: List$1<number>;
    s2(a: CategoryFrame, b: FinancialSeriesView): void;
    kx(a: boolean, b: SeriesView): void;
    gj(a: Point, b: boolean, c: boolean): number;
    hj(a: Point, b: boolean): number;
    hh(a: Point, b: boolean): number;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    s4(a: CategoryFrame, b: FinancialSeriesView): void;
    protected bx(): SeriesView;
    ly(a: SeriesView): void;
    private tq;
    protected sb(): number;
    gc(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
    static $t: Type;
    constructor(a: FinancialSeriesView);
    protected f: BollingerBandsOverlayView;
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class BollingerBandsOverlayView extends FinancialSeriesView {
    static $t: Type;
    b3: BollingerBandsOverlay;
    constructor(a: BollingerBandsOverlay);
    as(): void;
    protected by(): FinancialBucketCalculator;
    b5(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: (arg1: number) => number, e: (arg1: number) => number, f: (arg1: number) => number): void;
    b4(): void;
    get b7(): Polygon;
    get cc(): Polyline;
    get cd(): Polyline;
    get ce(): Polyline;
    private b8;
    private cf;
    private cg;
    private ch;
    private b6;
    private b9;
    private ca;
    private cb;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
