import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ChaikinOscillatorIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    static $t: Type;
    protected get_ug(): IndicatorCalculationStrategy;
    protected get ug(): IndicatorCalculationStrategy;
    protected get_ut(): Type;
    protected get ut(): Type;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    static readonly u2: DependencyProperty;
    protected uo(): number;
    get longPeriod(): number;
    set longPeriod(a: number);
    static readonly u1: DependencyProperty;
    protected ul(): number;
}
