import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ConsolidatedItemsPosition } from "./ConsolidatedItemsPosition";
import { SeriesView } from "./SeriesView";
import { SeriesVisibleRangeMode } from "./SeriesVisibleRangeMode";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Rect } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ColumnSeries extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    protected get_dh(): boolean;
    protected get_d2(): boolean;
    protected gu(): number;
    protected bx(): SeriesView;
    u6: ColumnSeriesView;
    ly(a: SeriesView): void;
    b3(): SeriesVisibleRangeMode;
    protected ry(): CategoryTransitionInMode;
    constructor();
    va: number;
    vb: number;
    protected get_c2(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private vc;
    pu(a: Point): Rect;
    ev(a: Point, b: boolean): boolean;
    kx(a: boolean, b: SeriesView): void;
    ga(): number;
    s6(a: CategoryFrame, b: CategorySeriesView): void;
    private u7;
    get u8(): ConsolidatedItemsPosition;
    set u8(a: ConsolidatedItemsPosition);
    private u9;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ColumnSeriesView extends AnchoredCategorySeriesView {
    static $t: Type;
    as(): void;
    protected da: ColumnSeries;
    constructor(a: ColumnSeries);
    di(): Rectangle;
    protected dc: List$1<Rectangle>;
    dd(a: Rectangle): void;
    df(a: Rectangle): void;
    de(a: Rectangle): void;
    dg(a: Rectangle, b: number, c: number): void;
    protected ac(a: number): any;
    private dh;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    db: Pool$1<Rectangle>;
    al(a: any): void;
}
