import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { Path } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CrosshairLayer extends AnnotationLayer {
    static $t: Type;
    protected get_db(): boolean;
    protected get_c9(): boolean;
    constructor();
    protected bx(): SeriesView;
    ly(a: SeriesView): void;
    protected q9: CrosshairLayerView;
    tm: Brush;
    tn: Brush;
    r0: string;
    ra: Series;
    rf: boolean;
    rd: boolean;
    xAxisAnnotationFormatLabel: (item: any) => string;
    rb(): boolean;
    yAxisAnnotationFormatLabel: (item: any) => string;
    rc(): boolean;
    tq: Brush;
    to: Brush;
    ri: number;
    ru: number;
    tp: Brush;
    get tu(): Thickness;
    rk: number;
    rm: number;
    rl: number;
    rj: number;
    get tv(): Thickness;
    rq: number;
    rs: number;
    rr: number;
    rp: number;
    rn: number;
    tt: Brush;
    tr: Brush;
    ro: number;
    rv: number;
    ts: Brush;
    rt: number;
    tx: Visibility;
    tw: Visibility;
    re: boolean;
    protected qo(a: Series, b: boolean): void;
    protected qq(a: Frame, b: SeriesView): void;
    protected qb(a: Series): boolean;
    lr(): void;
    private sr;
    private rh;
    private rg;
    protected ss(a: CrosshairLayerFrame, b: boolean): void;
    private sq;
    protected qt(a: Frame, b: SeriesView): void;
    protected em(): boolean;
    protected l3(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CrosshairLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CrosshairLayer);
    protected b4: CrosshairLayer;
    b5: Pool$1<Path>;
    protected b6: List$1<Path>;
    as(): void;
    private cc;
    private b7;
    private b9;
    private b8;
    ca(a: Path, b: number, c: number, d: number): void;
    cb(a: Brush): Brush;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
