import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    static $t: Type;
    constructor();
    protected get_ug(): IndicatorCalculationStrategy;
    protected get ug(): IndicatorCalculationStrategy;
    protected get_ut(): Type;
    protected get ut(): Type;
    get u1(): number;
    set u1(a: number);
    static readonly u6: DependencyProperty;
    protected um(): number;
    uv(a: number): void;
    get smoothingPeriod(): number;
    set smoothingPeriod(a: number);
    static readonly u7: DependencyProperty;
    protected uo(): number;
    get u3(): number;
    set u3(a: number);
    static readonly u8: DependencyProperty;
    protected ul(): number;
    protected tw(): number;
}
