import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ItemwiseIndicatorCalculationStrategy } from "./ItemwiseIndicatorCalculationStrategy";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ItemwiseStrategyBasedIndicator extends StrategyBasedIndicator {
    static $t: Type;
    u1: ItemwiseIndicatorCalculationStrategy;
    abstract get u2(): ItemwiseIndicatorCalculationStrategy;
    protected get_ug(): IndicatorCalculationStrategy;
    protected get ug(): IndicatorCalculationStrategy;
    constructor();
    protected uu(): void;
}
