/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { BollingerBandWidthIndicatorStrategy } from "./BollingerBandWidthIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let BollingerBandWidthIndicator = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicator extends StrategyBasedIndicator {
        get_ug() {
            return new BollingerBandWidthIndicatorStrategy();
        }
        get ug() {
            return this.get_ug();
        }
        get_ut() {
            return BollingerBandWidthIndicator.$;
        }
        get ut() {
            return this.get_ut();
        }
        get u2() {
            return typeGetValue(this.c(BollingerBandWidthIndicator.u5));
        }
        set u2(a) {
            this.h(BollingerBandWidthIndicator.u5, a);
        }
        um() {
            return this.u2;
        }
        get u1() {
            return this.c(BollingerBandWidthIndicator.u4);
        }
        set u1(a) {
            this.h(BollingerBandWidthIndicator.u4, a);
        }
        uk() {
            return this.u1;
        }
    }
    BollingerBandWidthIndicator.$t = markType(BollingerBandWidthIndicator, 'BollingerBandWidthIndicator', StrategyBasedIndicator.$);
    BollingerBandWidthIndicator.u5 = StrategyBasedIndicator.uy(20, BollingerBandWidthIndicator.$);
    BollingerBandWidthIndicator.u4 = StrategyBasedIndicator.ux(2, BollingerBandWidthIndicator.$);
    return BollingerBandWidthIndicator;
})();
