/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { OnBalanceVolumeIndicatorStrategy } from "./OnBalanceVolumeIndicatorStrategy";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let OnBalanceVolumeIndicator = /*@__PURE__*/ (() => {
    class OnBalanceVolumeIndicator extends StrategyBasedIndicator {
        get_ug() {
            return new OnBalanceVolumeIndicatorStrategy();
        }
        get ug() {
            return this.get_ug();
        }
        get_ut() {
            return OnBalanceVolumeIndicator.$;
        }
        get ut() {
            return this.get_ut();
        }
    }
    OnBalanceVolumeIndicator.$t = markType(OnBalanceVolumeIndicator, 'OnBalanceVolumeIndicator', StrategyBasedIndicator.$);
    return OnBalanceVolumeIndicator;
})();
