import { IgxAssigningSeriesStyleEventArgsBase } from "./igx-assigning-series-style-event-args-base";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*/
export class IgxAssigningSeriesShapeStyleEventArgsBase extends IgxAssigningSeriesStyleEventArgsBase {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets stroke thickness to use for the current item.
    */
    get strokeThickness() {
        return this.i.t;
    }
    set strokeThickness(v) {
        this.i.t = +v;
    }
    /**
     * Gets or sets corner radius X to use for the current item, if applicable.
    */
    get radiusX() {
        return this.i.r;
    }
    set radiusX(v) {
        this.i.r = +v;
    }
    /**
     * Gets or sets corner radius Y to use for the current item, if applicable.
    */
    get radiusY() {
        return this.i.s;
    }
    set radiusY(v) {
        this.i.s = +v;
    }
}
