/**
 * Represents a calculation strategy that takes in a column of values
 * and returns a resulting column of values.
*/
export class IgxColumnSupportingCalculation {
    constructor() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    findByName(name) {
        return null;
    }
}
