import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { StackedFragmentSeries as StackedFragmentSeries_internal } from './StackedFragmentSeries';
import { IgxStackedFragmentSeriesComponent as IgxStackedFragmentSeriesComponent } from './igx-stacked-fragment-series-component';
export class IgxStackedSeriesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxStackedFragmentSeriesComponent.$type) {
            IgxStackedFragmentSeriesComponent.$type = markType(IgxStackedFragmentSeriesComponent, "IgxStackedFragmentSeriesComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxStackedFragmentSeriesComponent.$type) {
            IgxStackedFragmentSeriesComponent.$type = markType(IgxStackedFragmentSeriesComponent, "IgxStackedFragmentSeriesComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxStackedFragmentSeriesComponent.$type, StackedFragmentSeries_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxStackedFragmentSeriesComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
