/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-angular-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-angular-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-angular-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-angular-core";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-angular-core";
import { IChartScaleLegend_$type } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, logBase } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
var BubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeries, _super);
    function BubbleSeries() {
        var _this = _super.call(this) || this;
        _this.wu = null;
        _this.wt = null;
        _this.vh = null;
        _this.u9 = null;
        _this.u8 = null;
        _this.u7 = null;
        _this.u5 = null;
        _this.ab = BubbleSeries.$;
        _this.r2 = new ScatterFrame();
        _this.r4 = new ScatterFrame();
        _this.r0 = new ScatterFrame();
        return _this;
    }
    BubbleSeries.prototype.get_c4 = function () {
        return true;
    };
    BubbleSeries.prototype.bx = function () {
        return new BubbleSeriesView(this);
    };
    BubbleSeries.prototype.ly = function (a) {
        _super.prototype.ly.call(this, a);
        this.u4 = a;
    };
    BubbleSeries.prototype.gv = function () {
        return 0.7;
    };
    BubbleSeries.prototype.p6 = function () {
        if (this.p5 == 0) {
            return 2;
        }
        return _super.prototype.p6.call(this);
    };
    BubbleSeries.prototype.isAttachedTo = function (a) {
        return this.a1 == a;
    };
    BubbleSeries.prototype.c3 = function () {
        return true;
    };
    BubbleSeries.prototype.k9 = function (a) {
        _super.prototype.k9.call(this, a);
        if (this.vc != null && this.vh != null && this.vh.count > 0) {
            for (var b = 0; b < this.vh.count; b++) {
                a(this.vh._inner[b]);
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "vb", {
        get: function () {
            return this.vd;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.ws = function (a) {
        var b = typeCast(CustomPaletteBrushScale.$, this.u3);
        var c = typeCast(ValueBrushScale.$, this.u3);
        var d = this.u3;
        if (b != null && this.ck != null) {
            return b.getBrush1(a, this.ck.count);
        }
        else if (c != null) {
            return c.getBrushByIndex(a, this.va);
        }
        else if (d != null) {
            return d.getBrush(a);
        }
        return null;
    };
    Object.defineProperty(BubbleSeries.prototype, "legendReady", {
        get: function () {
            return this.vd != null && this.vd.count != 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "minScaleText", {
        get: function () {
            var a = this.u2(this.u6).b;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "maxScaleText", {
        get: function () {
            var a = this.u2(this.u6).a;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.forScaleColors = function (a) {
        for (var b = 0; b < this.vd.count; b++) {
            if (this.u3 == null || !this.u3.isReady) {
                return false;
            }
            var c = NaN;
            if (this.va != null) {
                c = (this.va.item(b) - this.va.minimum) / (this.va.maximum - this.va.minimum);
            }
            var d = (this.vd.item(b) - this.vd.minimum) / (this.vd.maximum - this.vd.minimum);
            if (isNaN_(c)) {
                c = 0;
            }
            if (isNaN_(d)) {
                d = c;
            }
            var e = this.rc;
            var f = this.ws(b);
            var g = f != null ? f : e;
            a(g, d);
        }
        return true;
    };
    BubbleSeries.prototype.hw = function (a, b) {
        var c = this.jq(b);
        if (c == BubbleSeries.$$p[5]) {
            return this.hx(a, b, this.vw);
        }
        if (c == BubbleSeries.$$p[11]) {
            return this.hx(a, b, this.v6);
        }
        if (c == ScatterBase.$$p[10]) {
            return this.hx(a, b, this.td);
        }
        if (c == ScatterBase.$$p[14]) {
            return this.hx(a, b, this.tl);
        }
        if (c == BubbleSeries.$$p[2]) {
            return this.hx(a, b, this.vr);
        }
        return _super.prototype.hw.call(this, a, b);
    };
    Object.defineProperty(BubbleSeries.prototype, "vd", {
        get: function () {
            return this.u9;
        },
        set: function (a) {
            if (this.u9 != a) {
                var b = this.vd;
                this.u9 = a;
                this.raisePropertyChanged("RadiusColumn", b, this.vd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "vc", {
        get: function () {
            return this.u8;
        },
        set: function (a) {
            if (this.u8 != a) {
                var b = this.vc;
                this.u8 = a;
                this.raisePropertyChanged("LabelColumn", b, this.vc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "va", {
        get: function () {
            return this.u7;
        },
        set: function (a) {
            if (this.u7 != a) {
                var b = this.va;
                this.u7 = a;
                this.raisePropertyChanged("FillColumn", b, this.va);
            }
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.to = function (a, b, c, d, e) {
        if (c <= this.sx) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        }
        var f = this.sx;
        var g = this.ck;
        var h;
        var i;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(0, d, e, this.rw.d, j);
        var l = new ScalerParams(0, d, e, this.rw.e, j);
        var m = false;
        var n = 0;
        if (this.cd != null) {
            if (this.cd.e3()) {
                var o = this.cd.ku(d, k);
                m = o.c;
                n = o.d;
            }
        }
        var _loop_1 = function (p) {
            h = this_1.sc.item(p);
            i = this_1.sd.item(p);
            var q = { $type: Point_$type, x: this_1.rw.a.ei(h, k), y: this_1.rw.b.ei(i, l) };
            if (m) {
                if (q.x < e.left || q.x > e.right) {
                    if (q.x + n >= e.left && q.x + n <= e.right) {
                        q = { $type: Point_$type, x: q.x + n, y: i };
                    }
                }
            }
            if (!isInfinity(q.x) && !isInfinity(q.y)) {
                var r_1 = g.item(p);
                if (c <= f) {
                    if (!b.g.containsKey(r_1)) {
                        var s_1 = { $type: Point_$type, x: h, y: i };
                        b.g.addItem(r_1, ((function () {
                            var $ret = new OwnedPoint();
                            $ret.a = r_1;
                            $ret.b = s_1;
                            $ret.c = q;
                            return $ret;
                        })()));
                    }
                }
            }
        };
        var this_1 = this;
        for (var p = 0; p < c; p++) {
            _loop_1(p);
        }
    };
    BubbleSeries.prototype.tw = function (a, b) {
        var c = typeCast(BubbleSeriesView.$, b);
        var d = c.cv;
        d.m = this.vd;
        _super.prototype.tw.call(this, a, b);
        var e = Math.min(this.sc != null ? this.sc.count : 0, this.sd != null ? this.sd.count : 0);
        if (e < 1) {
            return;
        }
        c.dh();
        c.di();
    };
    BubbleSeries.prototype.wb = function () {
        if (this.cd == null) {
            return;
        }
        if (this.a1 == null) {
            return;
        }
        if (this.a1.isItemwise) {
            var a = this.a1;
            this.a1.clearLegendItemsForSeries(this);
            this.wa();
            a.renderItemwiseContent(this);
        }
        if (this.a1.isScale) {
            var b = this.a1;
            b.restoreOriginalState();
            b.initializeLegend(this);
        }
    };
    BubbleSeries.vi = function (a, b, c, d, e) {
        if (e <= a || isNaN_(e) || isInfinity(e)) {
            return c;
        }
        if (e >= b) {
            return d;
        }
        var f = c + ((d - c) / (b - a)) * (e - a);
        return f;
    };
    BubbleSeries.vj = function (a, b, c, d, logBase_, e) {
        var f = logBase(e, logBase_);
        var g = logBase(a, logBase_);
        var h = logBase(b, logBase_);
        return BubbleSeries.vi(g, h, c, d, f);
    };
    BubbleSeries.prototype.e9 = function (a, b, c) {
        var d = _super.prototype.e9.call(this, a, b, c);
        if (this.vd == null || this.ck == null || this.vd.count == 0 || this.ck.count != this.vd.count) {
            d = false;
        }
        return d;
    };
    BubbleSeries.prototype.sl = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.td == a || this.tl == a || this.v6 == a) {
            return true;
        }
        return false;
    };
    BubbleSeries.prototype.wa = function () {
        var _this = this;
        var a = typeCast(IChartLegend_$type, this.a1);
        if (a == null || this.ck == null) {
            return;
        }
        this.vh = new List$1(UIElement.$, 0);
        var b = typeCast(CustomPaletteBrushScale.$, this.u3);
        var c = typeCast(ValueBrushScale.$, this.u3);
        var d = this.u3;
        var e = this.u1();
        var f = e.b;
        var g = e.a;
        var h = this.ck;
        var _loop_2 = function (i) {
            var j = null;
            if (c != null && this_2.va != null) {
                var k = this_2.va.item(i);
                j = c.getBrushByRange(k, f, g);
            }
            else if (b != null) {
                j = b.getBrush1(i, h.count);
            }
            else if (d != null) {
                j = d.getBrush(i);
            }
            var l = new ContentControl();
            var m = this_2.vc != null && this_2.vc.item(i) != null ? this_2.vc.item(i).toString() : "";
            l.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this;
                $ret.item = h.item(i);
                $ret.itemBrush = j;
                $ret.itemLabel = m;
                return $ret;
            })());
            var n = this_2.nb;
            if (n == null) {
                n = this_2.b0.bl(this_2.b5);
            }
            l.ah = n;
            this_2.vh.add(l);
        };
        var this_2 = this;
        for (var i = 0; i < h.count; i++) {
            _loop_2(i);
        }
    };
    BubbleSeries.prototype.k0 = function (a, b, c, d) {
        _super.prototype.k0.call(this, a, b, c, d);
        if (this.u6 != null) {
            this.u6.aa();
        }
        if (this.u3 != null) {
            this.u3.x();
        }
        this.wb();
    };
    BubbleSeries.prototype.lh = function () {
        _super.prototype.lh.call(this);
        this.wb();
    };
    BubbleSeries.prototype.ln = function () {
        _super.prototype.ln.call(this);
        this.wb();
    };
    BubbleSeries.prototype.l3 = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.l3.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (this.u6 != null) {
                    this.u6.aa();
                }
                if (this.u3 != null) {
                    this.u3.x();
                }
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.vd);
                    c.deregisterColumn(this.va);
                    c.deregisterColumn(this.vc);
                    this.vd = null;
                    this.va = null;
                    this.vc = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.vd = this.ch(this.v6);
                    if (!stringIsNullOrEmpty(this.vr)) {
                        this.va = this.ch(this.vr);
                    }
                    this.vc = this.cj(this.vw);
                }
                this.mh(false);
                this.wb();
                break;
            case BubbleSeries.$$p[11]:
                if (this.u6 != null) {
                    this.u6.aa();
                }
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.vd);
                    this.vd = this.ch(this.v6);
                    this.wb();
                }
                break;
            case "RadiusColumn":
                if (this.u6 != null) {
                    this.u6.aa();
                }
                this.rx.cx.g$i();
                this.mh(false);
                this.lp();
                break;
            case BubbleSeries.$$p[12]:
                if (c != null) {
                    c.l.remove(this);
                    c.aa();
                }
                if (d != null) {
                    d.l.add(this);
                    d.aa();
                }
                this.mh(false);
                this.lo();
                break;
            case BubbleSeries.$$p[13]:
                this.mh(false);
                this.lo();
                break;
            case "DiscreteLegendItemTemplate":
                this.wb();
                break;
            case BubbleSeries.$$p[3]:
                if (c != null) {
                    c.o.remove(this);
                    c.x();
                }
                if (d != null) {
                    d.o.add(this);
                    d.x();
                }
                this.mh(false);
                this.wb();
                this.lo();
                break;
            case BubbleSeries.$$p[4]:
            case BubbleSeries.$$p[8]:
            case BubbleSeries.$$p[7]:
            case BubbleSeries.$$p[6]:
                this.mh(false);
                this.wb();
                this.lo();
                break;
            case "FillColumn":
                this.mh(false);
                this.lo();
                break;
            case BubbleSeries.$$p[2]:
                if (this.u3 != null) {
                    this.u3.x();
                }
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.va);
                    this.va = this.ch(this.vr);
                    this.wb();
                }
                break;
            case BubbleSeries.$$p[5]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.vc);
                    this.vc = this.cj(this.vw);
                    this.wb();
                }
                break;
            case "ActualLegend":
                var e = typeCast(IChartLegend_$type, c);
                if (e != null && e.isItemwise) {
                    var f = typeCast(IChartItemLegend_$type, e);
                    f.clearLegendItemsForSeries(this);
                }
                if (e != null && e.isScale) {
                    var g = typeCast(IChartScaleLegend_$type, e);
                    var h = true;
                    var i = null;
                    if (this.cd != null) {
                        try {
                            for (var _b = __values(fromEnum(this.cd.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var j = _c.value;
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                    }
                    if (h) {
                        g.restoreOriginalState();
                    }
                    else {
                        g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                    }
                }
                this.wb();
                break;
            case "SeriesViewer":
                this.wb();
                break;
        }
    };
    BubbleSeries.prototype.updateSizeScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.vd != null) {
            a.b = this.vd.minimum;
            a.a = this.vd.maximum;
        }
        if (this.u6 != null) {
            this.u6.ab(a.b, a.a);
        }
    };
    BubbleSeries.prototype.updateFillScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.va != null) {
            a.b = this.va.minimum;
            a.a = this.va.maximum;
        }
        if (this.u3 != null) {
            this.u3.z(a.b, a.a);
        }
    };
    BubbleSeries.prototype.u2 = function (a) {
        var b = new ActualRange();
        b.b = NaN;
        b.a = NaN;
        if (this.vd != null) {
            b.b = this.vd.minimum;
            b.a = this.vd.maximum;
        }
        if (a != null) {
            a.x();
            if (this.vg) {
                b.b = a.globalMinimum;
                b.a = a.globalMaximum;
            }
        }
        return b;
    };
    BubbleSeries.prototype.u1 = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.va != null) {
            a.b = this.va.minimum;
            a.a = this.va.maximum;
        }
        var b = typeCast(ValueBrushScale.$, this.u3);
        if (b != null) {
            b.s();
            if (this.ve && this.u3.o.count > 1) {
                a.b = b.q;
                a.a = b.p;
            }
        }
        return a;
    };
    BubbleSeries.prototype.wd = function (a, b, c, d) {
        var e = c.width;
        if (!this.b0.bu.isEmpty) {
            e = this.b0.bu.width;
        }
        else if (this.cd != null && !this.cd.su.isEmpty) {
            e = this.cd.su.width;
        }
        var f = DeviceUtils.c(e);
        this.u5 = this.u6 || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = f / 10;
            $ret.maximumValue = f / 5;
            return $ret;
        })());
        if (this.u5 != null) {
            var g = this.u5.minimumValue;
            var h = this.u5.maximumValue;
            var i = this.u5.logarithmBase;
            var j = this.u2(this.u5);
            var k = j.b;
            var l = j.a;
            if (this.u5.isLogarithmic) {
                for (var m = 0; m < b.count; m++) {
                    b._inner[m] = BubbleSeries.vj(k, l, g, h, i, b._inner[m]);
                }
            }
            else {
                for (var n = 0; n < b.count; n++) {
                    b._inner[n] = BubbleSeries.vi(k, l, g, h, b._inner[n]);
                }
            }
        }
        var o = 1;
        o = DeviceUtils.d();
        var p = this.u6 == null;
        if (d) {
            var q = c.width / e;
            for (var r = 0; r < b.count; r++) {
                if (p) {
                    b._inner[r] = b._inner[r] / o;
                }
                b._inner[r] = b._inner[r] * q;
            }
        }
        for (var s = 0; s < a.count; s++) {
            var t = a._inner[s];
            if (p && !d) {
                t.width = Math.max(0, b._inner[s] / o);
                t.height = Math.max(0, b._inner[s] / o);
            }
            else {
                t.width = Math.max(0, b._inner[s]);
                t.height = Math.max(0, b._inner[s]);
            }
        }
    };
    BubbleSeries.prototype.wc = function (a) {
        var b = typeCast(BubbleSeriesView.$, this.bz);
        this.u4.b3 = false;
        if (b != null) {
            b.b3 = false;
        }
        var c = typeCast(CustomPaletteBrushScale.$, this.u3);
        var d = typeCast(ValueBrushScale.$, this.u3);
        var e = this.u3;
        var f = this.u1();
        var g = f.b;
        var h = f.a;
        var i = this.u3 == null || !this.u3.isReady || (d != null && this.vr == null);
        if (i) {
            this.u4.dg();
            if (b != null) {
                b.dg();
            }
            return;
        }
        this.u4.b3 = true;
        if (b != null) {
            b.b3 = true;
        }
        var j = a.count;
        var k = this.ck;
        for (var l = 0; l < j; l++) {
            var m = a._inner[l];
            var n = typeCast(DataContext.$, m.content);
            if (n != null) {
                var o = null;
                var p = k.indexOf(n.item);
                if (c != null) {
                    o = c.getBrush1(p, k.count);
                }
                else if (d != null && this.va != null) {
                    var q = this.va.item(p);
                    o = d.getBrushByRange(q, g, h);
                }
                else if (e != null) {
                    o = e.getBrush(p);
                }
                else {
                    if (this.re == null) {
                        o = this.rc;
                    }
                    else {
                        o = this.re;
                    }
                }
                var r = null;
                if (this.rf == null) {
                    r = this.rd;
                }
                else {
                    r = this.rf;
                }
                if (this.vf && o != null) {
                    r = o;
                }
                if (r != null && !isNaN_(this.vl)) {
                    r = BrushUtil.l(r, this.vl);
                }
                if (o != null && !isNaN_(this.vk)) {
                    o = BrushUtil.l(o, this.vk);
                }
                n.itemBrush = o;
                n.actualItemBrush = o;
                n.outline = r;
            }
        }
    };
    BubbleSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.ht(c);
        var e = d == null ? NaN : this.gb(d, "XMemberPath");
        var f = d == null ? NaN : this.gb(d, "YMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.a = 13;
        g.l = e;
        g.p = this.td != null ? this.td : "X";
        g.q = this.s9 != null ? this.s9 : "X:";
        g.r = this.tb != null ? this.tb : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 14;
        h.p = this.tl != null ? this.tl : "Y";
        h.q = this.th != null ? this.th : "Y:";
        h.r = this.tj != null ? this.tj : "";
        var i = new DataLegendSeriesContext();
        i.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.b = this.av();
        if (!stringIsNullOrEmpty(this.v6)) {
            var j = d == null ? NaN : this.gb(d, "RadiusMemberPath");
            var k = new DataLegendSeriesValueInfo();
            k.l = j;
            k.a = 11;
            k.p = this.v6 != null ? this.v6 : "Radius";
            k.q = this.v2 != null ? this.v2 : "R:";
            k.r = this.v4 != null ? this.v4 : "";
            i.f.add(k);
        }
        else if (this.u5 != null) {
            var l = new DataLegendSeriesValueInfo();
            l.l = this.u5.maximumValue;
            l.a = 11;
            l.p = this.v6 != null ? this.v6 : "Radius";
            l.q = this.v2 != null ? this.v2 : "R:";
            l.r = this.v4 != null ? this.v4 : "";
            i.f.add(l);
        }
        if (!stringIsNullOrEmpty(this.vr)) {
            var m = d == null ? NaN : this.gb(d, "FillMemberPath");
            var n = new DataLegendSeriesValueInfo();
            n.l = m;
            n.a = 12;
            n.p = this.vr != null ? this.vr : "Fill";
            n.q = this.vn != null ? this.vn : "F:";
            n.r = this.vp != null ? this.vp : "";
            i.f.add(n);
        }
        return i;
    };
    Object.defineProperty(BubbleSeries.prototype, "actualMarkerBrush", {
        get: function () {
            return this.rc;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:vn:we', [2, null], 'FillMemberAsLegendUnit:vp:wf', [2, null], 'FillMemberPath:vr:wg', [2], 'FillScale:u3:wh', [BrushScale.$], 'FillScaleUseGlobalValues:ve:wi', [0, false], 'LabelMemberPath:vw:wj', [2], 'MarkerBrushBrightness:vk:wk', [1, NaN], 'MarkerOutlineBrightness:vl:wl', [1, NaN], 'MarkerOutlineUsesFillScale:vf:wm', [0, false], 'RadiusMemberAsLegendLabel:v2:wn', [2, null], 'RadiusMemberAsLegendUnit:v4:wo', [2, null], 'RadiusMemberPath:v6:wp', [2, null], 'RadiusScale:u6:wq', [SizeScale.$], 'RadiusScaleUseGlobalValues:vg:wr', [0, false]]);
    return BubbleSeries;
}(ScatterBase));
export { BubbleSeries };
/**
 * @hidden
 */
var CustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomPaletteBrushScale, _super);
    function CustomPaletteBrushScale() {
        return _super.call(this) || this;
    }
    CustomPaletteBrushScale.prototype.getBrush1 = function (a, b) {
        if (this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (this.brushSelectionMode == 0) {
            return _super.prototype.getBrush.call(this, a % this.brushes.count);
        }
        var c = BubbleSeries.vi(0, b - 1, 0, this.brushes.count - 1, a);
        return this.ab(c);
    };
    CustomPaletteBrushScale.prototype.get_isReady = function () {
        return this.brushes != null && this.brushes.count > 0;
    };
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
}(BrushScale));
export { CustomPaletteBrushScale };
/**
 * @hidden
 */
var BubbleSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeriesView, _super);
    function BubbleSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.df = null;
        _this.df = a;
        _this.cx = new ScatterTrendLineManager();
        return _this;
    }
    BubbleSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.b1.qc = Defaults.e;
        }
    };
    BubbleSeriesView.prototype.cu = function () {
        var _this = this;
        return new BubbleMarkerManager(function (a) { return _this.cy.item(a); }, function (a) { return _this.cw.rw.c.item(a); }, runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz));
    };
    BubbleSeriesView.prototype.dh = function () {
        var a = this.cv;
        this.df.wd(a.n, a.o, this.bu, this == this.e.bz);
        this.aq();
    };
    BubbleSeriesView.prototype.di = function () {
        var a = this.cv;
        this.df.wc(a.n);
    };
    BubbleSeriesView.prototype.dg = function () {
        var e_2, _a;
        var a = this.cv;
        try {
            for (var _b = __values(fromEnum(a.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    BubbleSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a6.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.df.title + "</span><br/><span>" + "(${item." + this.df.td + "}, ${item." + this.df.tl + "})</span>";
        if (!stringIsNullOrEmpty(this.df.v6)) {
            a += "<span>, Radius: ${item." + this.df.v6 + "}</span>";
        }
        a += "</div>";
        return a;
    };
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
}(ScatterBaseView));
export { BubbleSeriesView };
