import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class FastStochasticOscillatorIndicator extends StrategyBasedIndicator {
    static $t: Type;
    constructor();
    protected get_ug(): IndicatorCalculationStrategy;
    protected get ug(): IndicatorCalculationStrategy;
    protected get_ut(): Type;
    protected get ut(): Type;
    get u1(): number;
    set u1(a: number);
    static readonly u2: DependencyProperty;
    protected um(): number;
    uv(a: number): void;
}
