import { CategoryXAxis } from "./CategoryXAxis";
import { ITimeRangeSelectorAxis } from "./ITimeRangeSelectorAxis";
import { IOrdinalAxis } from "./IOrdinalAxis";
import { TimeAxisLabellingMode } from "./TimeAxisLabellingMode";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { CategoryMode } from "./CategoryMode";
import { IList$1, EventArgs, Type } from "igniteui-angular-core";
import { IGetItemAtIndex } from "igniteui-angular-core";
import { FastItemsSourceEventArgs } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class OrdinalTimeXAxis extends CategoryXAxis implements ITimeRangeSelectorAxis, IOrdinalAxis {
    static $t: Type;
    ek(a: number, b: Rect, c: Rect): number;
    ej(a: number, b: ScalerParams, c: CategoryMode): number;
    ei(a: number, b: ScalerParams): number;
    private np;
    hl(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    hm(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    en(a: number, b: Rect, c: Rect): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    el(a: number, b: ScalerParams): number;
    private nq;
    em(a: number, b: ScalerParams, c: CategoryMode): number;
    hn(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    constructor();
    protected hv(a: any, b: string, c: any, d: any): void;
    private nc;
    get actualMinimumValue(): Date;
    set actualMinimumValue(a: Date);
    private nb;
    get actualMaximumValue(): Date;
    set actualMaximumValue(a: Date);
    private ni;
    get visibleMinimum(): Date;
    set visibleMinimum(a: Date);
    private nh;
    get visibleMaximum(): Date;
    set visibleMaximum(a: Date);
    private ne;
    get nm(): Date;
    set nm(a: Date);
    private nd;
    get nl(): Date;
    set nl(a: Date);
    private n4;
    private n5;
    private ns;
    protected h8(a: boolean): void;
    private nr;
    get dateTimeMemberPath(): string;
    set dateTimeMemberPath(a: string);
    private m7;
    get m8(): TimeAxisLabellingMode;
    set m8(a: TimeAxisLabellingMode);
    protected get_cj(): boolean;
    private m9;
    private get na();
    private set na(value);
    protected ip(a: Rect, b: Rect): void;
    getWindowRectForSelection(a: Date, b: Date): Rect;
    private m5;
    get m6(): TimeAxisLabelFormatCollection;
    private n3;
    hx(a: string): void;
    fy(a: any): any;
    gc(a: number): string;
    getDateTime(a: number): Date;
    private get n2();
    private get nz();
    protected mh(): IGetItemAtIndex;
    protected io(a: Rect, b: Rect): void;
    protected mo(a: number, b: ScalerParams): number;
    protected mn(a: number, b: number, c: boolean, d: ScalerParams): number;
    private n1;
    private n0;
    itemLabelFormat(): string;
    private ng;
    get minimumValue(): Date;
    set minimumValue(a: Date);
    private nf;
    get maximumValue(): Date;
    set maximumValue(a: Date);
    c2(): boolean;
    visibleRangeChanged: (sender: any, e: EventArgs) => void;
    protected l1(a: FastItemsSourceEventArgs): void;
    get isVertical(): boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$a(): boolean;
}
