import { Series } from "./Series";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { IEnumerable, Type } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource } from "igniteui-angular-core";
import { TriangulationStatusEventArgs } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
/**
 * @hidden
 */
export declare abstract class ScatterTriangulationSeries extends Series {
    static $t: Type;
    ku(): void;
    q5: string;
    hw(a: any, b: string): any;
    rd: string;
    private qa;
    protected get qg(): IFastItemColumn$1<number>;
    protected set qg(a: IFastItemColumn$1<number>);
    private qb;
    protected get qh(): IFastItemColumn$1<number>;
    protected set qh(a: IFastItemColumn$1<number>);
    p3: NumericXAxis;
    p4: NumericYAxis;
    private qj;
    mi(a: boolean): void;
    private rh;
    private rf;
    private p6;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    private ri;
    protected qc(a: IFastItemsSource, b: string): IFastItemColumn$1<number>;
    protected l3(a: any, b: string, c: any, d: any): void;
    ql(a: any): boolean;
    qk(a: any): boolean;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    private rg;
    private qm;
    le(): void;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ap(a: Axis): AxisRange;
    protected m5(a: Rect, b: Rect): void;
    protected m4(a: Rect, b: Rect): void;
    trianglesSource: IEnumerable;
    qi: IFastItemsSource;
    qt: string;
    qv: string;
    qx: string;
    private p7;
    protected get qd(): IFastItemColumn$1<number>;
    protected set qd(a: IFastItemColumn$1<number>);
    private p8;
    protected get qe(): IFastItemColumn$1<number>;
    protected set qe(a: IFastItemColumn$1<number>);
    private p9;
    protected get qf(): IFastItemColumn$1<number>;
    protected set qf(a: IFastItemColumn$1<number>);
    protected get_ed(): boolean;
    protected get_d2(): boolean;
    q1: string;
    q9: string;
    q3: string;
    rb: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
