import { NumericAxisBase } from "./NumericAxisBase";
import { NumericScaleMode } from "./NumericScaleMode";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericScaler } from "./NumericScaler";
import { Type } from "igniteui-angular-core";
import { AxisView } from "./AxisView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
export declare abstract class StraightNumericAxisBase extends NumericAxisBase {
    static $t: Type;
    constructor();
    a3(): AxisView;
    hr(a: AxisView): void;
    nk: StraightNumericAxisBaseView;
    nf: NumericScaleMode;
    static readonly nx: DependencyProperty;
    get nj(): NumericScaler;
    set nj(a: NumericScaler);
    private static nt;
    protected ni(): NumericScaler;
    protected nh: NumericScaler;
    protected get_ng(): NumericScaler;
    protected set_ng(a: NumericScaler): void;
    get ng(): NumericScaler;
    set ng(a: NumericScaler);
    mw(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    private nu;
    private nl;
    protected nv(): void;
    nq(): void;
    protected hv(a: any, b: string, c: any, d: any): void;
    private ns;
    private nr;
    protected nm(a: number, b: StraightNumericAxisBase): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StraightNumericAxisBaseView extends NumericAxisBaseView {
    static $t: Type;
    protected bj: StraightNumericAxisBase;
    constructor(a: StraightNumericAxisBase);
    bk(): void;
}
