import { FinancialIndicator } from "./FinancialIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type, IList$1 } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { FinancialCalculationDataSource } from "./FinancialCalculationDataSource";
/**
 * @hidden
 */
export declare abstract class StrategyBasedIndicator extends FinancialIndicator {
    static $t: Type;
    constructor();
    protected uu(): void;
    protected uf: IndicatorCalculationStrategy;
    protected abstract get ug(): IndicatorCalculationStrategy;
    protected abstract get ut(): Type;
    static uj: List$1<string>;
    protected um(): number;
    uv(a: number): void;
    protected uo(): number;
    protected ul(): number;
    static uz(a: number, b: Type, c: string): DependencyProperty;
    protected static uy(a: number, b: Type): DependencyProperty;
    protected static uw(a: number, b: Type): DependencyProperty;
    protected static u0(a: number, b: Type): DependencyProperty;
    protected ts(a: number, b: number): IList$1<string>;
    protected tp(a: number, b: number): boolean;
    protected ui(a: FinancialCalculationDataSource): boolean;
    private uh;
    protected un(a: number): number;
    protected qo(a: number, b: number): FinancialCalculationDataSource;
    protected uk(): number;
    protected static ux(a: number, b: Type): DependencyProperty;
    protected l3(a: any, b: string, c: any, d: any): void;
}
