import { IgxAssigningSeriesShapeStyleEventArgsBase } from "./igx-assigning-series-shape-style-event-args-base";
import { AssigningCategoryStyleEventArgs as AssigningCategoryStyleEventArgs_internal } from "./AssigningCategoryStyleEventArgs";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `AssigningCategoryStyle` event fired to allow you to override the style of items in a category or financial series
*/
export declare class IgxAssigningCategoryStyleEventArgs extends IgxAssigningSeriesShapeStyleEventArgsBase {
    protected createImplementation(): AssigningCategoryStyleEventArgs_internal;
    /**
                                 * @hidden
                                 */
    get i(): AssigningCategoryStyleEventArgs_internal;
    constructor();
}
